org.sonatype.plexus.components.cipher

## Class Base64

- java.lang.Object
- - org.sonatype.plexus.components.cipher.Base64

    public class Base64
    extends java.lang.Object

Provides Base64 encoding and decoding as defined by RFC 2045.

This class implements section 6.8. Base64 Content-Transfer-Encoding from RFC 2045 Multipurpose Internet Mail Extensions (MIME) Part One: Format of Internet Message Bodies by Freed and Borenstein.

Since:
  1.0-dev
Version:
  $Id: Base64.java 765 2009-01-26 20:22:44Z oleg $
Author:
  Apache Software Foundation
See Also:
  RFC 2045

### Constructor Summary

Constructors
Constructor and Description
`Base64()`

### Method Summary

Methods
`byte[]` `decode(byte[] pArray)` Decodes a byte[] containing containing characters in the Base64 alphabet.
`java.lang.Object` `decode(java.lang.Object pObject)` Decodes an Object using the base64 algorithm.
`static byte[]` `decodeBase64(byte[] base64Data)` Decodes Base64 data into octects
`byte[]` `encode(byte[] pArray)` Encodes a byte[] containing binary data, into a byte[] containing characters in the Base64 alphabet.
`java.lang.Object` `encode(java.lang.Object pObject)` Encodes an Object using the base64 algorithm.
`static byte[]` `encodeBase64(byte[] binaryData)` Encodes binary data using the base64 algorithm but does not chunk the output.
`static byte[]` `encodeBase64(byte[] binaryData, boolean isChunked)` Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.
`static byte[]` `encodeBase64Chunked(byte[] binaryData)` Encodes binary data using the base64 algorithm and chunks the encoded output into 76 character blocks
`static boolean` `isArrayByteBase64(byte[] arrayOctect)` Tests a given byte array to see if it contains only valid characters within the Base64 alphabet.
`static boolean` `isBase64(byte b)` Returns whether or not the `octect` is in the base 64 alphabet.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Base64

    public Base64()

### Method Detail

#### isBase64

    public static boolean isBase64(byte b)

Returns whether or not the `octect` is in the base 64 alphabet.

Parameters:
  `b` - The value to test
Returns:
  `true` if the value is defined in the the base 64 alphabet, `false` otherwise.

#### isArrayByteBase64

    public static boolean isArrayByteBase64(byte[] arrayOctect)

Tests a given byte array to see if it contains only valid characters within the Base64 alphabet.

Parameters:
  `arrayOctect` - byte array to test
Returns:
  `true` if all bytes are valid characters in the Base64 alphabet or if the byte array is empty; false, otherwise

#### encodeBase64

    public static byte[] encodeBase64(byte[] binaryData)

Encodes binary data using the base64 algorithm but does not chunk the output.

Parameters:
  `binaryData` - binary data to encode
Returns:
  Base64 characters

#### encodeBase64Chunked

    public static byte[] encodeBase64Chunked(byte[] binaryData)

Encodes binary data using the base64 algorithm and chunks the encoded output into 76 character blocks

Parameters:
  `binaryData` - binary data to encode
Returns:
  Base64 characters chunked in 76 character blocks

#### decode

    public java.lang.Object decode(java.lang.Object pObject)
                            throws java.lang.IllegalArgumentException

Decodes an Object using the base64 algorithm. This method is provided in order to satisfy the requirements of the Decoder interface, and will throw a DecoderException if the supplied object is not of type byte[].

Parameters:
  `pObject` - Object to decode
Returns:
  An object (of type byte[]) containing the binary data which corresponds to the byte[] supplied.
Throws:
  `java.lang.IllegalArgumentException` - if the parameter supplied is not of type byte[]

#### decode

    public byte[] decode(byte[] pArray)

Decodes a byte[] containing containing characters in the Base64 alphabet.

Parameters:
  `pArray` - A byte array containing Base64 character data
Returns:
  a byte array containing binary data

#### encodeBase64

    public static byte[] encodeBase64(byte[] binaryData,
                      boolean isChunked)

Encodes binary data using the base64 algorithm, optionally chunking the output into 76 character blocks.

Parameters:
  `binaryData` - Array containing binary data to encode.
  `isChunked` - if `true` this encoder will chunk the base64 output into 76 character blocks
Returns:
  Base64-encoded data.

#### decodeBase64

    public static byte[] decodeBase64(byte[] base64Data)

Decodes Base64 data into octects

Parameters:
  `base64Data` - Byte array containing Base64 data
Returns:
  Array containing decoded data.

#### encode

    public java.lang.Object encode(java.lang.Object pObject)
                            throws java.lang.IllegalArgumentException

Encodes an Object using the base64 algorithm. This method is provided in order to satisfy the requirements of the Encoder interface, and will throw an EncoderException if the supplied object is not of type byte[].

Parameters:
  `pObject` - Object to encode
Returns:
  An object (of type byte[]) containing the base64 encoded data which corresponds to the byte[] supplied.
Throws:
  `java.lang.IllegalArgumentException` - if the parameter supplied is not of type byte[]

#### encode

    public byte[] encode(byte[] pArray)

Encodes a byte[] containing binary data, into a byte[] containing characters in the Base64 alphabet.

Parameters:
  `pArray` - a byte array containing binary data
Returns:
  A byte array containing only Base64 character data